package com.br.aulas;

import com.br.aulas.R;
import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.TextView;

public class AgendaActivity extends Activity implements OnClickListener {
	private View buttonGravar;
	private View buttonBuscar;
	private View buttonApagar;
	private EditText editId;
	private EditText editNome;
	private EditText editTelefone;
	private TextView strContatos;
	private ContatoDAO contatos;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
	
		strContatos = (TextView) findViewById(R.id.lableContatos);
		editId = (EditText) findViewById(R.id.editId);
		editNome = (EditText) findViewById(R.id.editNome);
		editTelefone = (EditText) findViewById(R.id.editTelefone);
		buttonGravar = findViewById(R.id.buttonGravar);
		buttonGravar.setOnClickListener(this);
		buttonBuscar = findViewById(R.id.buttonBuscar);
		buttonBuscar.setOnClickListener(this);
		buttonApagar = findViewById(R.id.buttonApagar);
		buttonApagar.setOnClickListener(this);

		DatabaseConnection.setConfig("myAgenda", getApplicationContext());
		contatos = new ContatoDAO();
		loadContatos();
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.buttonGravar:
			try {
				int id = Integer.valueOf(editId.getText().toString());
				Contato contato = contatos.getByID(id);
				if (contato != null) {
					contato.setNome(editNome.getText().toString());
					contato.setTelefone(editTelefone.getText().toString());
					contatos.update(contato);
				} else {
					contato = new Contato(id, editNome.getText().toString(),
							editTelefone.getText().toString());
					contatos.insert(contato);
				}
				limpar();
				loadContatos();
			} catch (Exception e) {
				dialogo("ERRO", "O codigo precisa ser inteiro");
			}
			break;
		case R.id.buttonBuscar:
			try {
				int id = Integer.valueOf(editId.getText().toString());
				Contato contato = contatos.getByID(id);
				if (contato != null) {
					editNome.setText(contato.getNome());
					editTelefone.setText(contato.getTelefone());
				} else {
					dialogo("Not Found", "Contato de codigo " + id
							+ " nao encontrado.");
				}
			} catch (Exception e) {
				dialogo("ERRO", "Informe em codigo um numero inteiro valido.");
			}
			break;
		case R.id.buttonApagar:
			try {
				int id = Integer.valueOf(editId.getText().toString());
				Contato contato = contatos.getByID(id);
				if (contato != null) {
					contatos.delete(contato);
				}
			} catch (Exception e) {
				dialogo("ERRO", "Informe em codigo um numero inteiro valido.");
			}
			loadContatos();
			limpar();
			break;
		}
	}

	public void dialogo(String titulo, String conteudo) {
		Builder builder = new Builder(AgendaActivity.this);
		builder.setTitle(titulo);
		builder.setMessage(conteudo);
		builder.setNeutralButton("OK", null);
		builder.show();
	}

	public void limpar() {
		editId.setText("");
		editNome.setText("");
		editTelefone.setText("");
	}

	public void loadContatos() {
		contatos.load();
		Contato contato = null;
		String str = "";
		while ((contato = contatos.next()) != null) {
			str += contato.toString() + "\n";
		}
		strContatos.setText(str);
	}
}