package com.br.aulas;

import java.util.ArrayList;
import java.util.List;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

public class ContatoDAO {
	private int Position;
	private List<Contato> contatoList;

	public ContatoDAO() {
		Position = 0;
		contatoList = new ArrayList<Contato>();
	}

	public void load() {
		clear();
		try {
			SQLiteDatabase conn = DatabaseConnection.getConnection();
			Cursor result = conn.query("agenda", null, null, null, null, null,
					"nome");
			while (result.moveToNext()) {
				int id = result.getInt(result.getColumnIndex("id"));
				String nome = result.getString(result.getColumnIndex("nome"));
				String telefone = result.getString(result
						.getColumnIndex("telefone"));
				Contato contato = new Contato(id, nome, telefone);
				contatoList.add(contato);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void insert(Contato contato) {
		try {
			SQLiteDatabase conn = DatabaseConnection.getConnection();
			String query = "insert into agenda (id, nome, telefone) "
					+ "values ('" + contato.getId() + "', '"
					+ contato.getNome() + "', '" + contato.getTelefone() + "')";
			conn.execSQL(query);
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.clear();
	}

	public void update(Contato contato) {
		try {
			SQLiteDatabase conn = DatabaseConnection.getConnection();
			String query = "update agenda set nome='" + contato.getNome()
					+ "', telefone='" + contato.getTelefone() + "' where id='"
					+ contato.getId() + "'";
			conn.execSQL(query);
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.clear();
	}

	public void delete(Contato contato) {
		try {
			SQLiteDatabase conn = DatabaseConnection.getConnection();
			String query = "delete from agenda where id='" + contato.getId()
					+ "'";
			conn.execSQL(query);
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.clear();
	}

	public Contato getByID(int id) {
		for (int i = 0; i < contatoList.size(); i++) {
			Contato contato = contatoList.get(i);
			if (contato.getId() == id) {
				return contato;
			}
		}
		return null;
	}

	public void clear() {
		Position = 0;
		contatoList.clear();
	}

	public void reset() {
		Position = 0;
	}

	public int size() {
		return contatoList.size();
	}

	public Contato next() {
		Contato func = null;
		if (Position < contatoList.size()) {
			func = contatoList.get(Position);
			Position++;
		}
		return func;
	}
}